#include "pm.h"
#include "title1.h"
#include "title2.h"
#include "sprite.h"

int fctr;
char ox=32;

int rcp(__reg("x") char*) = 
	"\tmov ba, [x]\n"\
  "\tex  ba, a\n"\
  "\tmov x, ba\n";


void __interrupt irq_1_prc_copy()
{
  // flip map
  if(fctr&1)
    PRC_MAP = (long)title1;
  else {
    PRC_MAP = (long)title2;
  }
  
  // flip sprite
  OAM[0].tile ^= 1;
  
  if(!(rcp(&KEY_PAD)&KEY_RIGHT))  OAM[0].x = rcp(&(OAM[0].x))+1;
  if(!(rcp(&KEY_PAD)&KEY_LEFT))   OAM[0].x = rcp(&(OAM[0].x))-1;
  
  if(!(rcp(&KEY_PAD)&KEY_DOWN))   OAM[0].y = rcp(&(OAM[0].y))+1;
  if(!(rcp(&KEY_PAD)&KEY_UP))     OAM[0].y = rcp(&(OAM[0].y))-1;

  fctr++;
  IRQ_ACT1 = IRQ1_PRC_COMPLETE;
}

int main()
{
  int a, x, y;
  PRC_MODE = COPY_ENABLE|SPRITE_ENABLE|MAP_ENABLE|MAP_16X12;
  PRC_RATE = RATE_6FPS;
  
  PRC_SCROLL_X=0;
  PRC_SCROLL_Y=0;
  
  OAM[0].x = 16;
  OAM[0].y = 16;
  OAM[0].tile = 0;
  OAM[0].ctrl = OAM_ENABLE;
  
  PRC_SPR = (long)sprite;
  
  for(y=0;y<8;y++)
    for(x=0;x<12;x++)
      TILEMAP[y*16+x] = x+y*12;
	
  // Enable PRC IRQ
  IRQ_ENA1 = IRQ1_PRC_COMPLETE;
  PRI_PRC(1);
  
  while(1);
}